commonap2by2 <- function(crit,p1,q1,np,nq) {

#  Returns the power of Pearson's statistic on 2 by 2 tables
#  caclulated by the common approach.
#
#  INPUT DATA
#        crit = critical value
#          p1 = probability that a controls falls in category 1.
#          q1 = probability that a case falls in category 1.
#          np = number of controls
#          nq = number of cases
#
#  OUTPUT DATA is the power calculated by the common approach.
#
#  CODES NEDEED: -
#

   n <- np+nq
   pp <- np/n
   qq <- nq/n

   p2 <- 1-p1
   q2 <- 1-q1

   noncold <- ((p1-q1)*(p1-q1)*n*pp*qq) / ((p1*pp+q1*qq)*(p2*pp+q2*qq))

   power <- 1 - pchisq(crit, 1, ncp=noncold)

   power

}




