pexact2by2 <- function(crit,p1,q1,np,nq) {

#  Returns the EXACT power of Pearson's statistic on 2 by 2 tables.
#
#  INPUT DATA
#        crit = critical value
#          p1 = probability that a controls falls in category 1.
#          q1 = probability that a case falls in category 1.
#          np = number of controls
#          nq = number of cases
#
#  OUTPUT DATA is the EXACT power.
#
#  CODES NEDEED: bino
#

   n <- np+nq
   pp <- np/n
   qq <- nq/n

   ts <- rep(0,(np+1)*(nq+1))
   probs <- rep(0,(np+1)*(nq+1))

   bi <- rep(0,np+1) 
   for (i in 0:np) bi[i+1] = bino(i,np,p1)
   bj <- rep(0,nq+1) 
   for (j in 0:nq) bj[j+1] = bino(j,nq,q1)

   aux <- 0
   eh <- n / (pp*qq)
   count <- 0
   for (i in 0:np) {
      for (j in 0:nq) {
          count = count + 1
          aux = qq*i-pp*j
          ts[count] = (eh * aux * aux) / ((i+j)*(n-i-j))
          probs[count] = bi[i+1]*bj[j+1]
      }
   }

   len <- (np+1)*(nq+1)
   tss <- ts[2:len-1]
   probss <- probs[2:len-1]
   len <- len-2

   ord <- order(tss)
   probsor <- rep(0,len)
   tsor <- rep(0,len)
   for (i in 1:len) {
       probsor[i] = probss[ord[i]]
       tsor[i] = tss[ord[i]]
   }


   newind <- rep(0,len)
   count <- 0
   for (i in 2:len) {
       if (tsor[i-1]<tsor[i]) {
          count = count + 1
          newind[count] = i
       }
   }

   t <- rep(0,count+1)
   t[1] = tsor[1]
   for (i in 1:count) t[i+1] = tsor[newind[i]]

   p <- rep(0,count+1)
   p[1] = sum( probsor[1:(newind[1]-1)] )
   for (i in 1:(count-1)) p[i+1] = sum( probsor[ (newind[i]):((newind[i+1])-1)] )


   p[count+1] = sum( probsor[newind[count]:len] )

   lenew <- count + 1
 

   comp <- rep(0,lenew)
   comp[1] = p[1]
   for (i in 2:lenew) comp[i] = comp[i-1] + p[i] 
 
   i <- lenew
   while(t[i]>crit) i = i - 1
   powe <- 1 - comp[i]

   powe 


}




