simulat2by2 <- function(crit,p1,q1,np,nq,N) {

#  Returns the power of Pearson's statistic on 2 by 2 tables
#  caclulated by simulation with N replications.
#
#  INPUT DATA
#        crit = critical value
#          p1 = probability that a controls falls in category 1.
#          q1 = probability that a case falls in category 1.
#          np = number of controls
#          nq = number of cases
#           N = number of replications
#
#  OUTPUT DATA is the simulated power.
#
#  CODES NEDEED: -
#

    n <- np+nq
    q2 <- 1 - q1
    p2 <- 1 - p1

    T <- 0  

    v11 <- 0
    v21 <- 0
    v12 <- 0
    v22 <- 0
    v1 <- 0
    v2 <- 0
    aux <- 0
    bux <- 0
    cux <- 0

    len <- N
    tss <- rep(0,N)
    rec <- 1/N
    probsor <- rep(rec,N)

    x <- c(0,1)
  
    for (i in 1:N) {

      v21 = sum( sample(x, np, replace = TRUE, prob=c(p1,p2)) )
      v11 = np - v21

      v22 = sum( sample(x, nq, replace = TRUE, prob=c(q1,q2)) )
      v12 = nq - v22


      v1 = v11 + v12 
      v2 = v21 + v22

      
      aux = v1*np
      bux = v11 - (aux/n)
      T = bux * bux / aux

      aux = v2*np
      bux = v21 - (aux/n)
      T = T + bux * bux / aux

      aux = v1*nq
      bux = v12 - (aux/n)
      T = T + bux * bux / aux

      aux = v2*nq
      bux = v22 - (aux/n)
      T = T + bux * bux / aux

      tss[i] = T * n

   } 

###################################

   tsor <- sort(tss)

   newind <- rep(0,len)
   count <- 0
   for (i in 2:len) {
       if (tsor[i-1]<tsor[i]) {
          count = count + 1
          newind[count] = i
       }
   }

   t <- rep(0,count+1)
   t[1] = tsor[1]
   for (i in 1:count) t[i+1] = tsor[newind[i]]

   p <- rep(0,count+1)
   p[1] = sum( probsor[1:(newind[1]-1)] )
   for (i in 1:(count-1)) p[i+1] = sum( probsor[ (newind[i]):((newind[i+1])-1)] )


   p[count+1] = sum( probsor[newind[count]:len] )

   lenew <- count + 1
 

   comp <- rep(0,lenew)
   comp[1] = p[1]
   for (i in 2:lenew) comp[i] = comp[i-1] + p[i] 

   i <- lenew
   while(t[i]>crit) i = i - 1
   power <- 1 - comp[i]

   power

}
